//+------------------------------------------------------------------+
//|                                                           DA.mq5 |
#property link      " pvm63@inbox.ru "
#property version   " 2010 07 08"
//------------- indicator settings  --------------
#property    indicator_separate_window
#property    indicator_buffers         7
#property    indicator_plots           2
#property  indicator_type1        DRAW_LINE
#property  indicator_color1       Blue 
#property  indicator_label1       "DA_1"
#property  indicator_style1       STYLE_SOLID
#property  indicator_width1       2
#property    indicator_type2         DRAW_LINE
#property    indicator_color2        Red
#property    indicator_label2        "DA_2"
#property    indicator_style2        STYLE_SOLID
#property    indicator_width2        2
#property  indicator_minimum     -150
#property  indicator_maximum      150
#include       <emaBarCount.mqh>
//------------------------------------------
 input int   Bar_Count= 150;     // -  Bar 
 double      Line_0[], Line_1[], //      
                ma1[],    ma2[],  ma3[], ma4[], ma5[];
 int MA_1_Period = 10,
     MA_2_Period = 20,
     MA_3_Period = 30,
     MA_4_Period = 40,
     MA_5_Period = 60,
      i, limit, bar, Count,  K, M, start,
     Mashtab=   80;      //    2
 static  bool    printed_1 = false;    //   
 static  bool    printed_2 = false; //     
//=================  Custom indicator initialization function  ================
int OnInit()
   {  // 1 
  SetIndexBuffer( 0, Line_0,INDICATOR_DATA);
  SetIndexBuffer( 1, Line_1,INDICATOR_DATA);
  SetIndexBuffer( 2, ma1,   INDICATOR_CALCULATIONS);
  SetIndexBuffer( 3, ma2,   INDICATOR_CALCULATIONS);
  SetIndexBuffer( 4, ma3,   INDICATOR_CALCULATIONS);
  SetIndexBuffer( 5, ma4,   INDICATOR_CALCULATIONS);
  SetIndexBuffer( 6, ma5,   INDICATOR_CALCULATIONS);
      string shortname;   
  IndicatorSetString(INDICATOR_SHORTNAME,    shortname); 
  PlotIndexSetString(0,PLOT_LABEL,shortname);   
  PlotIndexSetString(1,PLOT_LABEL,shortname);     
    IndicatorSetInteger(INDICATOR_DIGITS,0);  
//           
  ArraySetAsSeries( Line_0, false );
  ArraySetAsSeries( Line_1, false );
  ArraySetAsSeries( ma1,    false );
  ArraySetAsSeries( ma2,    false );
  ArraySetAsSeries( ma3,    false );
  ArraySetAsSeries( ma4,    false );
  ArraySetAsSeries( ma5,    false );
// ------------------------------------
 bar   = Bars(_Symbol,  _Period);
//  Print(" 0#   bar = ", bar, ",   _Period =", _Period );
 limit = bar -Bar_Count;
 Count = limit - MA_5_Period ; //   
 //  MA_5_Period,       
    PlotIndexSetInteger( 0,   PLOT_DRAW_BEGIN, limit  ); 
    PlotIndexSetInteger( 1,   PLOT_DRAW_BEGIN,  limit ); 
    
 //        
   if ( Count< 0  )
 Alert("       !!! "); 
 //        
   return(0); 
   } // 1     
// ===============   Expert deinitialization function  =================
void OnDeinit(const int reason)
   { // 2  
          // ---   
   } // 2  
// ===================================================================  
int  OnCalculate(
        const int rates_total,   //   price[]
        const int prev_calculated, //     
        const int begin, //    
        const double& price[] //   
      )
   { //3
 if(printed_1 == false) //  
   {  // 4 
 if( rates_total > bar ) 
    Alert("///    = .   = ");  
 if(begin >0 ) 
    Alert("  begin = ", begin);// begin     
  printed_1 = true;   //   ,      
   } // 4
 emaBarCount(rates_total,prev_calculated,
       begin,//          
       Bar_Count, // -       period
       MA_1_Period,      //   
       price,       //    
       ma1);  //               
 
 emaBarCount(rates_total,prev_calculated,begin,Bar_Count,MA_2_Period,price,ma2);       
 emaBarCount(rates_total,prev_calculated,begin,Bar_Count,MA_3_Period,price,ma3); 
 emaBarCount(rates_total,prev_calculated,begin,Bar_Count,MA_4_Period,price,ma4); 
 emaBarCount(rates_total,prev_calculated,begin,Bar_Count,MA_5_Period,price,ma5); 
  
 /*/ ------      - ---------------------  
 if(printed_2 == false) //  
   { // 5
      if(prev_calculated==0) //  
   { // 6    
    start = rates_total -1 - Bar_Count - MA_5_Period - begin;    
 Print("   1#   start = rates_total - Bar_Count - MA_5_Period - begin;  ");  
 Print("   2# start= ",start,", rates_total= ",rates_total,", Bar_Count= ",Bar_Count,", MA_5_Period= ", MA_5_Period);    
 Print("3#  i= 0,  = ",  -rates_total +1  );  
 Print("                  .  .  .   ");
         for(i= 0;  i< rates_total;  i++)  
         if(  ma1[i]>0)
 Print("4# i= ",i,", = ",i+1-rates_total,", price= ",price[i],", ma1= ",ma1[i]); 
 Print("  ");
   } // 6
    else 
   { // 7
  start= prev_calculated-1; 
   for   (i=start;  i<rates_total;i++)
   if(  ma1[i]>0)
  Print("   5# i= ",i,", = ",i+1-rates_total,", price= ",price[i],", ma1= ",ma1[i]); 
   } // 7
 printed_1 = true;   //   ,      
   } // 5
//  ------      - --------------------- 
*/

// ==     (      ==
 //    (prev_calculated == 0) limit=bar-Bar_Count      
 if(prev_calculated > 0) limit = rates_total - 1; // R/t    
     for(i=limit;i<rates_total;i++)
   { // 8
     if(ma3[i]> ma4[i] && ma4[i]> ma5[i]) K=100; else
     if(ma3[i]< ma4[i] && ma4[i]< ma5[i]) K=-100; else K=0;
         Line_0[i]=K;
         // Print(" 6#,  i= ",i," Line_0= ",Line_0[i]);
   if(ma1[i]> ma2[i] && ma2[i]> ma3[i]) M=100; else
   if(ma1[i]< ma2[i] && ma2[i]< ma3[i]) M=-100; else M=0;
         Line_1[i]=M * Mashtab /100 ;
        // Print(" 7#, Line_1= ", Line_1[i]); 
    } // 8
    i++;   
//------------------
    return (rates_total);
   } // 3   ====   ,    = ! :) ======== +